<template>
  <div
      :data-qa="dataQa"
      class="ob-order-route-card"
  >
    <div class="card-title">
      Маршрут <span>{{ value.pointFrom }}</span> → <span>{{ value.pointTo }}</span>
    </div>
    <div class="card-list">
      <div
          v-for="item in value.items"
          :key="item.uuid"
          class="card-list-item"
          :class="{ done: item.done, current: item.current, 'history-log': item.type == 'log', location: item.type == 'location', state: item.type == 'state' }"
      >
        <div
            v-if="item.type == 'log'"
            class="card-list-container"
        >
          <div class="history-log-time">
            {{ item.time }}<br>
            {{ item.date }}
          </div>
          <div class="history-log-type">
            {{ item.status }}
          </div>
          <div class="history-log-message">
            {{ item.message }}
          </div>
          <div class="radio-mapper"/>
        </div>
        <div
            v-if="item.type == 'location'"
            class="card-list-container"
        >
          <div class="card-list-container__first-row">
            <div class="location-address">
              <div class="location-head">
                <span class="icon pin"/>
                <div class="location-head__title">
                  {{ item.pointName }}
                </div>
              </div>
              <div class="location-text">
                {{ item.pointAddress }}
              </div>
            </div>
            <div class="location-time">
              <div class="location-head">
                <div class="location-head__title">
                  {{ item.time }}
                </div>
              </div>
              <div class="location-text">
                Слот от {{ item.date }}
              </div>
            </div>
            <div
                v-if="!item.eta"
                class="location-status"
                :class="{ waiting: !item.eta }"
            >
              <div class="location-text">
                {{ item.status }}
              </div>
            </div>
            <div
                v-if="item.eta"
                class="location-eta"
            >
              <div class="eta-block">
                ETA прогноз
              </div>
              <div class="eta-block time">
                <div class="eta-caption">
                  Прибытие
                </div>
                <span>{{ item.eta.plan.arrive }}</span>
              </div>
              <div class="eta-block time">
                <div class="eta-caption">
                  Убытие
                </div>
                <span>{{ item.eta.plan.depart }}</span>
              </div>
              <div
                  v-if="item.eta.fact"
                  class="eta-block"
              >
                Факт
              </div>
              <div
                  v-if="item.eta.fact"
                  class="eta-block time"
              >
                <span>{{ item.eta.fact.arrive }}</span>
              </div>
              <div
                  v-if="item.eta.fact"
                  class="eta-block time"
              >
                <span>{{ item.eta.fact.depart }}</span>
              </div>
            </div>
            <div
                v-if="item.works && item.works.length > 0"
                class="location-works"
            >
              <div
                  v-for="(work, idx) in item.works"
                  :key="`work-${idx}`"
                  class="location-work-list"
              >
                <div class="work-time">
                  <div>{{ work.time }}</div>
                  <div>{{ work.date }}</div>
                </div>
                <div class="work-type">
                  {{ work.type }}
                </div>
                <div class="work-description">
                  <div class="work-title">
                    {{ work.title }}
                  </div>
                  <div>{{ work.description }}</div>
                </div>
                <div class="work-icon">
                  <span class="icon role-domain-owner"/>
                </div>
                <div class="work-personal">
                  <div class="work-title">
                    {{ work.person }}
                  </div>
                  <div>{{ work.contractor }}</div>
                </div>
              </div>
            </div>
            <div
                v-if="item.point == 'from'"
                class="radio-mapper from"
            >
              <i class="icon route-loading"/>
            </div>
            <div
                v-if="item.point == 'to'"
                class="radio-mapper to"
            >
              <i class="icon route-unloading"/>
            </div>
          </div>
          <div class="route-radius">
            <div class="route-radius__item">
              Радиус стоянки: <span>{{item.parkingRadius || '—'}}</span>
            </div>
            <div class="route-radius__item">
              Радиус {{ item.point === 'from' ? 'погрузки' : 'разгрузки' }}: <span>{{item.targetRadius || '—'}}</span>
            </div>
          </div>
          <order-event
              v-for="(item, index) in item.events"
              :key="index"
              :data="item"
          />
        </div>
        <div
            v-if="item.type == 'state'"
            class="card-list-container"
        >
          <div>
            {{ item.message }}
          </div>
          <div class="radio-mapper"/>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import orderEvent from './TrackingOrderEvent';

export default {
  name: "TrackingRouteCard",
  components: {
    orderEvent,
  },
  props: {
    value: {
      type: [Object],
      default: () => {
        return {
          pointFrom: '',
          pointTo: '',
          items: []
        }
      }
    },
    dataQa: {
      type: String
    }
  },
  data() {
    return {}
  },
  computed: {},
  watch: {},
  mounted() {
  },
  methods: {},
}
</script>

<style lang="scss">
.ob-order-route-card {
  background-color: $background-white;

  .card-title {
    font-weight: bold;
    font-size: 20px;
    line-height: 28px;
  }

  .card-list {
    margin-left: 30px;
    margin-top: 15px;
    border-left: 2px dashed $color-grey-border;

    .card-list-item {
      padding: 15px 0 15px 41px;
      position: relative;

      &.done {
        &:before {
          content: '';
          position: absolute;
          display: block;
          top: 0px;
          left: -2px;
          width: 2px;
          height: 100%;
          background: $color-blue-navy-blue;
          z-index: 1;
        }

        .radio-mapper {
          border: 2px solid $color-blue-navy-blue;
        }
      }

      &:first-child {
        &:after {
          content: '';
          position: absolute;
          display: block;
          top: 0px;
          left: -2px;
          width: 2px;
          height: 50%;
          background: $background-white;
          z-index: 2;
        }
      }

      &:last-child {
        &:after {
          content: '';
          position: absolute;
          display: block;
          bottom: 0px;
          left: -2px;
          width: 2px;
          height: 50%;
          background: $background-white;
          z-index: 2;
        }
      }

      .radio-mapper {
        position: absolute;
        width: 16px;
        height: 16px;
        border: 1px solid $color-grey-border;
        background-color: $background-white;
        border-radius: 50%;
        top: 0;
        bottom: 0;
        left: -9px;
        margin: auto;
        z-index: 3;
      }

      .item-icon {
        background-repeat: no-repeat;
        background-size: contain;
        background-position: center;
        display: inline-block;
        vertical-align: middle;
      }

      .card-list-container {
        border-radius: 3px;

        &:after {
          display: block;
          content: '';
          clear: both;
        }
      }

      &.history-log {
        .card-list-container {
          background: $light-lavender;
          padding: 3px 20px;
          letter-spacing: 0.4px;
          text-transform: uppercase;
          font-variant: small-caps;
          font-size: 12px;
          line-height: 18px;
          min-height: 40px;

          .history-log-time {
            color: $color-grey-span;
            float: left;
            width: 65px;
            line-height: 18px;
          }

          .history-log-message {
            color: $color-text-base;
            margin: 0 144px 0 65px;
            padding: 10px 20px 5px 50px;
          }

          .history-log-type {
            padding: 10px;
            color: $color-grey-span;
            float: right;
            width: 144px;
          }
        }
      }

      &.history-log + .history-log {
        padding-top: 0;
        margin-top: -10px;

        :not(.current) {
          .radio-mapper {
            display: none;
          }
        }
      }

      &.location {
        .card-list-container {
          padding: 20px;
          background: $background-white;
          border: 1px solid $lavender;
          box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
          min-height: 104px;
          font-size: 12px;
          line-height: 18px;

          &__first-row {
            display: flex;
          }

          .radio-mapper {
            height: 30px;
            width: 30px;
            left: -16px;
            background-size: 10px 20px;
            background-position: center;
            background-repeat: no-repeat;
            display: flex;
            justify-content: center;
            align-items: center;

            &.from {
              .icon {
                color: $diamond-orange-yellow;
                font-size: 14px;
              }
            }

            &.to {
              .icon {
                color: $color-green-light;
                font-size: 14px;
              }
            }
          }

          .location-head {
            display: flex;
            font-size: 16px;
            line-height: 18px;
            letter-spacing: 0.2px;
            color: $color-text-base;
            margin-bottom: 6px;
            font-weight: normal;

            &__title {
              margin-top: 4px;
            }
          }

          .location-text {
            text-transform: uppercase;
            font-variant: small-caps;
            color: $color-grey-span;
            font-size: 10px;
            line-height: 16px;
            letter-spacing: 0.2px;
          }

          .location-address {
            width: 292px;
            margin-right: 10px;

            .icon {
              color: $color-blue-navy-blue;
              font-size: 25px;
              margin-right: 6px;
              vertical-align: middle;
            }
          }

          .location-time {
            .location-head {
              margin-bottom: 9px;
            }
          }

          .location-status {
            flex-grow: 2;
            text-align: center;
            align-self: center;
          }

          .location-eta {
            flex-grow: 2;
            display: flex;
            flex-wrap: wrap;

            .eta-block {
              width: 33%;
              font-size: 12px;
              line-height: 20px;
              color: $color-grey-span;
              font-variant: small-caps;
              text-transform: uppercase;
              margin-bottom: 5px;

              &.time {
                position: relative;

                > span {
                  font-size: 16px;
                  line-height: 20px;
                  letter-spacing: 0.2px;
                  color: $color-text-base;
                }

                .eta-caption {
                  position: absolute;
                  top: -43px;
                }
              }
            }
          }

          .location-works {
            padding-top: 5px;

            .location-work-list {
              display: flex;
              color: $color-grey-span;
              font-variant: small-caps;
              text-transform: uppercase;
              background: $light-lavender;
              border-radius: 3px;
              margin-bottom: 2px;
              padding: 10px 20px;

              .work-time {
                width: 80px;
              }

              .work-type {
                width: 70px;
                line-height: 30px;
              }

              .work-description {
                flex-grow: 1;

                .work-title {
                  color: $color-text-base;
                }
              }

              .work-icon {
                color: $color-blue-navy-blue;
                width: 40px;
                font-size: 20px;
                line-height: 30px;
                text-align: right;
                padding-right: 15px;

                .icon {
                  vertical-align: middle;
                }
              }

              .work-personal {
                width: 150px;

                .work-title {
                  color: $color-text-base;
                }
              }
            }
          }
        }
      }

      &.state {
        .card-list-container {
          padding: 15px 20px;
          background: $background-white;
          border: 1px solid $lavender;
          box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
          font-size: 16px;
          line-height: 18px;
          color: $color-text-base;
        }
      }

      &.current {
        &:before {
          content: '';
          position: absolute;
          display: block;
          top: 0px;
          left: -2px;
          width: 2px;
          height: 50%;
          background: $color-blue-navy-blue;
          z-index: 1;
        }

        .radio-mapper {
          border: 2px solid $color-blue-navy-blue;
        }

        &.location {
          .card-list-container {
            border: 2px solid $color-blue-navy-blue;
          }
        }

        &.state {
          .card-list-container {
            border: 2px solid $color-blue-navy-blue;
          }
        }
      }
    }
  }
}

.route-radius {
  display: flex;
  margin-top: 20px;
  margin-bottom: 20px;
  padding-left: 31px;
}

.route-radius__item {
  color: $gray-slate;

  &:not(:first-child) {
    margin-left: 20px;
  }

  span {
    color: $color-text-base;
  }
}
</style>